/******************************* sci.h *******************************/

#ifndef HEADER_SCI_H
#define HEADER_SCI_H

// ascii chars
#define CR   0x0D
#define LF   0x0A
#define BS   0x08
#define ESC  0x1B
#define SP   0x20       
#define DEL  0x7F

#define RDRF 0x20   // Receive Data Register Full Bit
#define TDRE 0x80   // Transmit Data Register Empty Bit


// size of buffer for integer printing
#define PRINT_BUFFER_SIZE 13

 
// sets the serial port baud rate to anything you like
// taking into account the system clock frequency
void SCI_Init(unsigned long int BaudRate);
    

// wait for data to fill SCI data register then return it
char SCI_InChar(void);

        
// wait for SCI data register to be empty, then fill it with the input value to send it over SCI
void SCI_OutChar(char data);



// Outputs a null terminated string over SCI
void SCI_OutString(char *pVal);


// Outputs a 16bit unsigned integer 0-65536
void SCI_OutUInt(unsigned short n);

// Outputs a 32bit unsigned integer
void SCI_OutULInt(unsigned long n);

// Outputs a 16bit unsigned integer
// fit to a certain minimum width
void SCI_OutUIntF(unsigned short n, unsigned char width);

// prints a character as hex
void SCI_OutHex(unsigned char data);

#endif

